import { z } from 'zod';
export declare const Operator: z.ZodObject<{
    name: z.ZodString;
    link: z.ZodString;
    type: z.ZodArray<z.ZodEnum<["accumulator", "stage", "query", "fieldQuery", "filter", "window", "geometry", "switchBranch", "resolvesToAny", "resolvesToNumber", "resolvesToDouble", "resolvesToString", "resolvesToObject", "resolvesToArray", "resolvesToBinData", "resolvesToObjectId", "resolvesToBool", "resolvesToDate", "resolvesToNull", "resolvesToRegex", "resolvesToJavascript", "resolvesToInt", "resolvesToTimestamp", "resolvesToLong", "resolvesToDecimal", "searchOperator"]>, "many">;
    encode: z.ZodEnum<["array", "object", "single"]>;
    description: z.ZodString;
    wrapObject: z.ZodDefault<z.ZodBoolean>;
    arguments: z.ZodOptional<z.ZodArray<z.ZodObject<{
        name: z.ZodString;
        type: z.ZodArray<z.ZodEnum<["accumulator", "query", "fieldQuery", "pipeline", "untypedPipeline", "window", "expression", "expressionMap", "geometry", "fieldPath", "unprefixedFieldPath", "timeUnit", "sortSpec", "any", "granularity", "fullDocument", "fullDocumentBeforeChange", "accumulatorPercentile", "whenMatched", "whenNotMatched", "outCollection", "range", "sortBy", "geoPoint", "resolvesToNumber", "numberFieldPath", "number", "resolvesToDouble", "doubleFieldPath", "double", "resolvesToString", "stringFieldPath", "string", "resolvesToObject", "objectFieldPath", "object", "resolvesToArray", "arrayFieldPath", "array", "resolvesToBinData", "binDataFieldPath", "binData", "resolvesToObjectId", "objectIdFieldPath", "objectId", "resolvesToBool", "boolFieldPath", "bool", "resolvesToDate", "dateFieldPath", "date", "resolvesToNull", "nullFieldPath", "null", "resolvesToRegex", "regexFieldPath", "regex", "resolvesToJavascript", "javascriptFieldPath", "javascript", "resolvesToInt", "intFieldPath", "int", "resolvesToTimestamp", "timestampFieldPath", "timestamp", "resolvesToLong", "longFieldPath", "long", "resolvesToDecimal", "decimalFieldPath", "decimal", "searchPath", "searchScore", "searchOperator", "searchHighlight"]>, "many">;
        description: z.ZodOptional<z.ZodString>;
        optional: z.ZodOptional<z.ZodBoolean>;
        valueMin: z.ZodOptional<z.ZodNumber>;
        valueMax: z.ZodOptional<z.ZodNumber>;
        variadic: z.ZodOptional<z.ZodEnum<["array", "object"]>>;
        variadicMin: z.ZodOptional<z.ZodNumber>;
        default: z.ZodOptional<z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodBoolean, z.ZodNumber, z.ZodString]>>;
        mergeObject: z.ZodDefault<z.ZodBoolean>;
        syntheticVariables: z.ZodOptional<z.ZodArray<z.ZodObject<{
            name: z.ZodString;
            description: z.ZodOptional<z.ZodString>;
        }, "strip", z.ZodTypeAny, {
            name: string;
            description?: string | undefined;
        }, {
            name: string;
            description?: string | undefined;
        }>, "many">>;
    }, "strict", z.ZodTypeAny, {
        name: string;
        type: ("string" | "number" | "object" | "date" | "null" | "array" | "accumulator" | "query" | "fieldQuery" | "window" | "geometry" | "resolvesToNumber" | "resolvesToDouble" | "resolvesToString" | "resolvesToObject" | "resolvesToArray" | "resolvesToBinData" | "resolvesToObjectId" | "resolvesToBool" | "resolvesToDate" | "resolvesToNull" | "resolvesToRegex" | "resolvesToJavascript" | "resolvesToInt" | "resolvesToTimestamp" | "resolvesToLong" | "resolvesToDecimal" | "searchOperator" | "pipeline" | "untypedPipeline" | "expression" | "expressionMap" | "fieldPath" | "unprefixedFieldPath" | "timeUnit" | "sortSpec" | "any" | "granularity" | "fullDocument" | "fullDocumentBeforeChange" | "accumulatorPercentile" | "whenMatched" | "whenNotMatched" | "outCollection" | "range" | "sortBy" | "geoPoint" | "numberFieldPath" | "doubleFieldPath" | "double" | "stringFieldPath" | "objectFieldPath" | "arrayFieldPath" | "binDataFieldPath" | "binData" | "objectIdFieldPath" | "objectId" | "boolFieldPath" | "bool" | "dateFieldPath" | "nullFieldPath" | "regexFieldPath" | "regex" | "javascriptFieldPath" | "javascript" | "intFieldPath" | "int" | "timestampFieldPath" | "timestamp" | "longFieldPath" | "long" | "decimalFieldPath" | "decimal" | "searchPath" | "searchScore" | "searchHighlight")[];
        mergeObject: boolean;
        default?: string | number | boolean | any[] | undefined;
        description?: string | undefined;
        optional?: boolean | undefined;
        valueMin?: number | undefined;
        valueMax?: number | undefined;
        variadic?: "object" | "array" | undefined;
        variadicMin?: number | undefined;
        syntheticVariables?: {
            name: string;
            description?: string | undefined;
        }[] | undefined;
    }, {
        name: string;
        type: ("string" | "number" | "object" | "date" | "null" | "array" | "accumulator" | "query" | "fieldQuery" | "window" | "geometry" | "resolvesToNumber" | "resolvesToDouble" | "resolvesToString" | "resolvesToObject" | "resolvesToArray" | "resolvesToBinData" | "resolvesToObjectId" | "resolvesToBool" | "resolvesToDate" | "resolvesToNull" | "resolvesToRegex" | "resolvesToJavascript" | "resolvesToInt" | "resolvesToTimestamp" | "resolvesToLong" | "resolvesToDecimal" | "searchOperator" | "pipeline" | "untypedPipeline" | "expression" | "expressionMap" | "fieldPath" | "unprefixedFieldPath" | "timeUnit" | "sortSpec" | "any" | "granularity" | "fullDocument" | "fullDocumentBeforeChange" | "accumulatorPercentile" | "whenMatched" | "whenNotMatched" | "outCollection" | "range" | "sortBy" | "geoPoint" | "numberFieldPath" | "doubleFieldPath" | "double" | "stringFieldPath" | "objectFieldPath" | "arrayFieldPath" | "binDataFieldPath" | "binData" | "objectIdFieldPath" | "objectId" | "boolFieldPath" | "bool" | "dateFieldPath" | "nullFieldPath" | "regexFieldPath" | "regex" | "javascriptFieldPath" | "javascript" | "intFieldPath" | "int" | "timestampFieldPath" | "timestamp" | "longFieldPath" | "long" | "decimalFieldPath" | "decimal" | "searchPath" | "searchScore" | "searchHighlight")[];
        default?: string | number | boolean | any[] | undefined;
        description?: string | undefined;
        optional?: boolean | undefined;
        valueMin?: number | undefined;
        valueMax?: number | undefined;
        variadic?: "object" | "array" | undefined;
        variadicMin?: number | undefined;
        mergeObject?: boolean | undefined;
        syntheticVariables?: {
            name: string;
            description?: string | undefined;
        }[] | undefined;
    }>, "many">>;
    tests: z.ZodOptional<z.ZodArray<z.ZodObject<{
        name: z.ZodString;
        link: z.ZodOptional<z.ZodString>;
        pipeline: z.ZodArray<z.ZodRecord<z.ZodString, z.ZodAny>, "many">;
        schema: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodRecord<z.ZodString, z.ZodRecord<z.ZodString, z.ZodObject<{
            types: z.ZodArray<z.ZodUnion<[z.ZodObject<{
                bsonType: z.ZodEnum<["Array", "Binary", "Boolean", "Code", "CodeWScope", "Date", "Decimal128", "Double", "Int32", "Int64", "Long", "MaxKey", "MinKey", "Null", "ObjectId", "BSONRegExp", "String", "BSONSymbol", "Timestamp", "Undefined", "Document", "Number"]>;
            }, "strict", z.ZodTypeAny, {
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            }, {
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            }>, z.ZodObject<{
                bsonType: z.ZodLiteral<"Array">;
                types: z.ZodArray<z.ZodRecord<z.ZodString, z.ZodAny>, "many">;
            }, "strict", z.ZodTypeAny, {
                types: Record<string, any>[];
                bsonType: "Array";
            }, {
                types: Record<string, any>[];
                bsonType: "Array";
            }>, z.ZodObject<{
                bsonType: z.ZodLiteral<"Document">;
                fields: z.ZodRecord<z.ZodString, z.ZodRecord<z.ZodString, z.ZodAny>>;
            }, "strict", z.ZodTypeAny, {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            }, {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            }>]>, "many">;
        }, "strict", z.ZodTypeAny, {
            types: ({
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            } | {
                types: Record<string, any>[];
                bsonType: "Array";
            } | {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            })[];
        }, {
            types: ({
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            } | {
                types: Record<string, any>[];
                bsonType: "Array";
            } | {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            })[];
        }>>>]>>;
    }, "strict", z.ZodTypeAny, {
        name: string;
        pipeline: Record<string, any>[];
        link?: string | undefined;
        schema?: string | Record<string, Record<string, {
            types: ({
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            } | {
                types: Record<string, any>[];
                bsonType: "Array";
            } | {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            })[];
        }>> | undefined;
    }, {
        name: string;
        pipeline: Record<string, any>[];
        link?: string | undefined;
        schema?: string | Record<string, Record<string, {
            types: ({
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            } | {
                types: Record<string, any>[];
                bsonType: "Array";
            } | {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            })[];
        }>> | undefined;
    }>, "many">>;
}, "strict", z.ZodTypeAny, {
    link: string;
    name: string;
    type: ("filter" | "accumulator" | "stage" | "query" | "fieldQuery" | "window" | "geometry" | "switchBranch" | "resolvesToAny" | "resolvesToNumber" | "resolvesToDouble" | "resolvesToString" | "resolvesToObject" | "resolvesToArray" | "resolvesToBinData" | "resolvesToObjectId" | "resolvesToBool" | "resolvesToDate" | "resolvesToNull" | "resolvesToRegex" | "resolvesToJavascript" | "resolvesToInt" | "resolvesToTimestamp" | "resolvesToLong" | "resolvesToDecimal" | "searchOperator")[];
    encode: "object" | "array" | "single";
    description: string;
    wrapObject: boolean;
    arguments?: {
        name: string;
        type: ("string" | "number" | "object" | "date" | "null" | "array" | "accumulator" | "query" | "fieldQuery" | "window" | "geometry" | "resolvesToNumber" | "resolvesToDouble" | "resolvesToString" | "resolvesToObject" | "resolvesToArray" | "resolvesToBinData" | "resolvesToObjectId" | "resolvesToBool" | "resolvesToDate" | "resolvesToNull" | "resolvesToRegex" | "resolvesToJavascript" | "resolvesToInt" | "resolvesToTimestamp" | "resolvesToLong" | "resolvesToDecimal" | "searchOperator" | "pipeline" | "untypedPipeline" | "expression" | "expressionMap" | "fieldPath" | "unprefixedFieldPath" | "timeUnit" | "sortSpec" | "any" | "granularity" | "fullDocument" | "fullDocumentBeforeChange" | "accumulatorPercentile" | "whenMatched" | "whenNotMatched" | "outCollection" | "range" | "sortBy" | "geoPoint" | "numberFieldPath" | "doubleFieldPath" | "double" | "stringFieldPath" | "objectFieldPath" | "arrayFieldPath" | "binDataFieldPath" | "binData" | "objectIdFieldPath" | "objectId" | "boolFieldPath" | "bool" | "dateFieldPath" | "nullFieldPath" | "regexFieldPath" | "regex" | "javascriptFieldPath" | "javascript" | "intFieldPath" | "int" | "timestampFieldPath" | "timestamp" | "longFieldPath" | "long" | "decimalFieldPath" | "decimal" | "searchPath" | "searchScore" | "searchHighlight")[];
        mergeObject: boolean;
        default?: string | number | boolean | any[] | undefined;
        description?: string | undefined;
        optional?: boolean | undefined;
        valueMin?: number | undefined;
        valueMax?: number | undefined;
        variadic?: "object" | "array" | undefined;
        variadicMin?: number | undefined;
        syntheticVariables?: {
            name: string;
            description?: string | undefined;
        }[] | undefined;
    }[] | undefined;
    tests?: {
        name: string;
        pipeline: Record<string, any>[];
        link?: string | undefined;
        schema?: string | Record<string, Record<string, {
            types: ({
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            } | {
                types: Record<string, any>[];
                bsonType: "Array";
            } | {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            })[];
        }>> | undefined;
    }[] | undefined;
}, {
    link: string;
    name: string;
    type: ("filter" | "accumulator" | "stage" | "query" | "fieldQuery" | "window" | "geometry" | "switchBranch" | "resolvesToAny" | "resolvesToNumber" | "resolvesToDouble" | "resolvesToString" | "resolvesToObject" | "resolvesToArray" | "resolvesToBinData" | "resolvesToObjectId" | "resolvesToBool" | "resolvesToDate" | "resolvesToNull" | "resolvesToRegex" | "resolvesToJavascript" | "resolvesToInt" | "resolvesToTimestamp" | "resolvesToLong" | "resolvesToDecimal" | "searchOperator")[];
    encode: "object" | "array" | "single";
    description: string;
    wrapObject?: boolean | undefined;
    arguments?: {
        name: string;
        type: ("string" | "number" | "object" | "date" | "null" | "array" | "accumulator" | "query" | "fieldQuery" | "window" | "geometry" | "resolvesToNumber" | "resolvesToDouble" | "resolvesToString" | "resolvesToObject" | "resolvesToArray" | "resolvesToBinData" | "resolvesToObjectId" | "resolvesToBool" | "resolvesToDate" | "resolvesToNull" | "resolvesToRegex" | "resolvesToJavascript" | "resolvesToInt" | "resolvesToTimestamp" | "resolvesToLong" | "resolvesToDecimal" | "searchOperator" | "pipeline" | "untypedPipeline" | "expression" | "expressionMap" | "fieldPath" | "unprefixedFieldPath" | "timeUnit" | "sortSpec" | "any" | "granularity" | "fullDocument" | "fullDocumentBeforeChange" | "accumulatorPercentile" | "whenMatched" | "whenNotMatched" | "outCollection" | "range" | "sortBy" | "geoPoint" | "numberFieldPath" | "doubleFieldPath" | "double" | "stringFieldPath" | "objectFieldPath" | "arrayFieldPath" | "binDataFieldPath" | "binData" | "objectIdFieldPath" | "objectId" | "boolFieldPath" | "bool" | "dateFieldPath" | "nullFieldPath" | "regexFieldPath" | "regex" | "javascriptFieldPath" | "javascript" | "intFieldPath" | "int" | "timestampFieldPath" | "timestamp" | "longFieldPath" | "long" | "decimalFieldPath" | "decimal" | "searchPath" | "searchScore" | "searchHighlight")[];
        default?: string | number | boolean | any[] | undefined;
        description?: string | undefined;
        optional?: boolean | undefined;
        valueMin?: number | undefined;
        valueMax?: number | undefined;
        variadic?: "object" | "array" | undefined;
        variadicMin?: number | undefined;
        mergeObject?: boolean | undefined;
        syntheticVariables?: {
            name: string;
            description?: string | undefined;
        }[] | undefined;
    }[] | undefined;
    tests?: {
        name: string;
        pipeline: Record<string, any>[];
        link?: string | undefined;
        schema?: string | Record<string, Record<string, {
            types: ({
                bsonType: "Array" | "Binary" | "Boolean" | "Code" | "CodeWScope" | "Date" | "Decimal128" | "Double" | "Int32" | "Int64" | "Long" | "MaxKey" | "MinKey" | "Null" | "ObjectId" | "BSONRegExp" | "String" | "BSONSymbol" | "Timestamp" | "Undefined" | "Document" | "Number";
            } | {
                types: Record<string, any>[];
                bsonType: "Array";
            } | {
                bsonType: "Document";
                fields: Record<string, Record<string, any>>;
            })[];
        }>> | undefined;
    }[] | undefined;
}>;
//# sourceMappingURL=metaschema.d.ts.map